import 'package:analyzer/dart/element/element.dart';
import 'package:like_sealed_gen/src/content/sealed_collection_content.dart';
import 'package:like_sealed_gen/src/content/sealed_switch_content.dart';
import 'package:like_sealed_gen/src/content/sealed_switch_impl_content.dart';
import 'package:like_sealed_gen/src/util.dart';

class ContentFormat {
  final imports = <String>[];

  String build(
      List<String> imports, String className, List<ClassElement> types) {
    var content = "";
    content += _imports(imports);
    content += "import 'package:like_sealed/sealed_switch.dart';\n";
    content += "import 'package:meta/meta.dart';\n";
    content += SealedCollectionContent(className, types).content();
    content += SealedSwitchContent(className, types).content();
    content += SealedSwitchImplContent(className, types).content();
    return content;
  }

  String _imports(List<String> imports) {
    var out = "";
    for (var import in imports) {
      out += "import '$import';\n";
    }
    return out;
  }
}
