import 'package:analyzer/dart/element/element.dart';
import 'package:like_sealed_gen/src/util.dart';

class SealedSwitchContent {
  final String className;
  final List<ClassElement> types;

  SealedSwitchContent(this.className, this.types);

  String content() {
    String typeChecker = "";
    String caseFunction = "";
    for (var type in types) {
      final typeName = type.name;
      if (typeName == className) {
        typeChecker += "onDefault(type)";
        caseFunction += "T onDefault($typeName ${typeName.firstToLower});";
      } else {
        typeChecker += "type is $typeName? on$typeName(type): ";
        caseFunction += "T on$typeName($typeName ${typeName.firstToLower});";
      }
    }

    return """
    abstract class ${className}Switch<T> implements SealedSwitch<$className,T> {
      T switchCase($className type)=>$typeChecker;
      $caseFunction
    }
    """;
  }
}
